#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <alloc.h>

void checkerrors(void);
void drawbmp(char *filename);
void setmode(int mode);
void setrgb(unsigned char col, unsigned char r, unsigned char g, unsigned char b);
void showpal(void);

int gdriver, gmode=0;
bool first=false;

int main(int argc, char *argv[])
{
   char c, c_;

   asm mov ax, 0C00h
   asm int 21h

   if (argc>1)
   {
     gdriver = installuserdriver("BGI256V2", NULL);
     checkerrors();

     drawbmp(argv[1]);

     do
     {
       c=getch();
       switch (c)
       {
         case 'p': showpal(); break;
         case 60: gmode=0; break;
         case 61: gmode=1; break;
         case 62: gmode=2; break;
         case 63: gmode=3; break;
         case 64: gmode=4; break;
         case 65: gmode=5; break;
       }
       if ((c>59)*(c<66)*(c_!=gmode))
       {
         closegraph();
         setmode(gmode);
         drawbmp(argv[1]);
       }
       c_=gmode;
     } while (c!=27);

     closegraph();
     restorecrtmode();
   }
   else printf("Not enough actual parameters\n");
   return 0;
}

void checkerrors(void)
{
   int errorcode;

   errorcode = graphresult();
   if (errorcode != grOk) {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);
   }
}

void drawbmp(char *filename)
{
  FILE *f;
  int i, j, x=0, y, cx, cy;
  unsigned long w, h;
  unsigned char b, bits=8, n;
  unsigned char *buf;
  buf=(unsigned char *)malloc(1024);

  f=fopen(filename, "rb");
  fseek(f, 18, 0);
  fread(&w, 4, 1, f);
  fread(&h, 4, 1, f);
  fseek(f, 54, 0);

  asm
  {
    mov ax, 1
    mov cl, bits
    shl ax, cl
    mov j, ax
  }

  fread(buf, 4*j, 1, f);

  y=h-1;

  if (!first)
  {
    if (w>h)
    {
      if (w>320) gmode=2;
      if (w>640) gmode=3;
      if (w>800) gmode=4;
    }
    else
    {
      if (h>200) gmode=1;
      if (h>400) gmode=2;
      if (h>480) gmode=3;
      if (h>600) gmode=4;
    }
    setmode(gmode);
    first=true;
  }

  cx=(getmaxx()+1)/2-w/2;
  cy=(getmaxy()+1)/2-h/2;

  for (i=0;i<j;i++)
    setrgb(i, buf[i*4+2], buf[i*4+1], buf[i*4]);

  fread(buf, w/(8/bits), 1, f);

  while (!feof(f))
  {
    for (j=0;j<w/(8/bits);j++)
    {
      b=buf[j];

        if(x>w-1)
        {
          x=0;
          y--;
        }
      for (n=0;n<8/bits;n++)
      {
        if (bits!=8)
        asm
        {
          xor ah, ah
          mov al, n
          mov bl, bits
          mul bl
          mov cl, al
          mov al, b
          shl al, cl
          mov cl, 8
          sub cl, bits
          shr al, cl
        }
        else _AL=b;

        putpixel(x+cx, y+cy, _AL);
        x++;

        if(x>w-1)
        {
          x=0;
          y--;
        }
      }
    }
    fread(buf, w/(8/bits), 1, f);
  }

  fclose(f);
  free(buf);
}

void setmode(int mode)
{
   initgraph(&gdriver, &mode, "");
   checkerrors();
}

void setrgb(unsigned char col, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
    mov  dx, 03C8h
    mov al, col
    out dx, al
    inc dx
    mov al, r
    shr al, 2
    out dx, al
    mov al, g
    shr al, 2
    out dx, al
    mov al, b
    shr al, 2
    out dx, al
  }
}

void showpal(void)
{
  int i, j;

  for (i=0;i<16;i++)
  for (j=0;j<16;j++)
  {
    setfillstyle(1, j*16+i);
    bar(i*16, j*8, i*16+15, j*8+7);
  }
}