#ifndef _ERROR_H_
#define _ERROR_H_
#include <iostream.h>
#include <dos.h>

void graph_error(int errorcode);
void error_exit(char *exception);

void graph_error(int errorcode)
{
  switch (errorcode)
  {
    case grNoInitGraph     : cout << "(BGI) graphics not installed (use initgraph)\n"; break;
    case grNotDetected     : cout << "Graphics hardware not detected\n"; break;
    case grFileNotFound    : cout << "Device driver file not found\n"; break;
    case grInvalidDriver   : cout << "Invalid device driver file\n"; break;
    case grNoLoadMem       : cout << "Not enough memory to load driver\n"; break;
    case grNoScanMem       : cout << "Out of memory in scan fill\n"; break;
    case grNoFloodMem      : cout << "Out of memory in flood fill\n"; break;
    case grFontNotFound    : cout << "Font file not found\n"; break;
    case grNoFontMem       : cout << "Not enough memory to load font\n"; break;
    case grInvalidMode     : cout << "Invalid graphics mode for selected driver\n"; break;
    case grError           : cout << "Graphics error\n"; break;
    case grIOerror         : cout << "Graphics I/O error\n"; break;
    case grInvalidFont     : cout << "Invalid font file\n"; break;
    case grInvalidFontNum  : cout << "Invalid font number\n"; break;
    case grInvalidVersion  : cout << "Invalid version number\n";
  }
}

void error_exit(char *exception)
{
  struct REGPACK reg;
  closegraph();
  cout << exception;
  reg.r_ax = 0x4C01;
  intr(0x21, &reg);
}

#endif

