#ifndef _MOUSE_H_
#define _MOUSE_H_
#include <graphics.h>
#include <dos.h>
#include "defs.h"
#include "graphics.h"

int x, y, b, x1, y1, b1;
int m_x = 0, m_y = 0, m_b = 0;
int visible = 1;
unsigned char *buf = new char[512];
int kb_control = 0;

int mouse_init();
void mouse_show();
void mouse_hide();
void mouse_read(int &x, int &y, int &buttons);
void mouse_set_pos(int x, int y);
void mouse_read_on_down(int &x, int &y, int button);
void mouse_read_on_up(int &x, int &y, int button);
void set_mouse_range(int xmin, int xmax, int ymin, int ymax);
void set_exception_region(int x1, int y1, int x2, int y2);
void DrawMouse();

void MouseShape()
{
//  setwritemode(XOR_PUT);
//  if (!b)
//    setcolor(WHITE);
//  else
//  {
//    setcolor(RED);
//    line(x - 2, y, x - 5, y);
//    line(x, y - 2, x, y - 5);
//    line(x - 2, y - 2, x - 4, y - 4);
//    line(x + 2, y - 2, x + 4, y - 4);
//    line(x - 2, y + 2, x - 4, y + 4);
//    line(x + 2, y, x + 5, y);
//  }
//  moveto(x, y);
//  lineto(x, y + 32);
//  lineto(x + 8, y + 28);
//  lineto(x + 14, y + 40);
//  lineto(x + 22, y + 36);
//  lineto(x + 16, y + 24);
//  lineto(x + 24, y + 20);
//  lineto(x, y);
//  setwritemode(COPY_PUT);
  putimage(x, y, MASK_ADDR, OR_PUT);
  putimage(x, y, CURSOR_ADDR, AND_PUT);
}

int mouse_init()
{
  struct REGPACK reg;
  reg.r_ax = 0;
  intr(0x33, &reg);
  if (reg.r_ax == 0xFFFF)
  {
    kb_control = False;
    return 1;
  }
  else
    kb_control = True;
  asm
  {
      mov    ax,  1ah
      mov    bx,  32
      mov    cx,  48
      mov    dx,  64
      int    33h
  }
  return 0;
}

void mouse_show()
{
  struct REGPACK reg;
  reg.r_ax = 1;
  intr(0x33, &reg);
  getimage(x, y, x + 16, y + 24, buf);
  visible = 1;
  putimage(x, y, buf, COPY_PUT);
  MouseShape();
}

void mouse_hide()
{
  struct REGPACK reg;
  reg.r_ax = 2;
  intr(0x33, &reg);
  putimage(x1, y1, buf, COPY_PUT);
  visible = 0;
}

void mouse_read(int &x, int &y, int &buttons)
{
  struct REGPACK reg;
  if (!kb_control)
  {
    reg.r_ax = 3;
    intr(0x33, &reg);
    x = reg.r_cx;
    y = reg.r_dx;
    buttons = reg.r_bx;
  }
  else
  {
    x = m_x;
    y = m_y;
    buttons = m_b;
  }
}

void mouse_set_pos(int x, int y)
{
  m_x = x;
  m_y = y;
  if (m_x < 0) m_x = 0;
  if (m_y < 0) m_y = 0;
  if (m_x > 623) m_x = 623;
  if (m_y > 460) m_y = 460;
  struct REGPACK reg;
  reg.r_ax = 4;
  reg.r_cx = x;
  reg.r_dx = y;
  intr(0x33, &reg);
  mouse_read(x, y, b);
  x1 = x;
  y1 = y;
  b1 = b;
  ::x = x;
  ::y = y;
  getimage(x, y, x + 16, y + 24, buf);
//  MouseShape();
}

void mouse_read_on_down(int &x, int &y, int button)
{
  struct REGPACK reg;
  reg.r_ax = 5;
  reg.r_bx = button;
  intr(0x33, &reg);
  x = reg.r_cx;
  y = reg.r_dx;
}

void mouse_read_on_up(int &x, int &y, int button)
{
  struct REGPACK reg;
  reg.r_ax = 6;
  reg.r_bx = button;
  intr(0x33, &reg);
  x = reg.r_cx;
  y = reg.r_dx;
}

void set_mouse_range(int xmin, int xmax, int ymin, int ymax)
{
  struct REGPACK reg;
  reg.r_ax = 7;
  reg.r_cx = xmin;
  reg.r_dx = xmax;
  intr(0x33, &reg);
  reg.r_ax = 8;
  reg.r_cx = ymin;
  reg.r_dx = ymax;
  intr(0x33, &reg);
}

void set_exception_region(int x1, int y1, int x2, int y2)
{
  struct REGPACK reg;
  reg.r_ax = 0x10;
  reg.r_cx = x1;
  reg.r_dx = y1;
  reg.r_si = x2;
  reg.r_di = y2;
  intr(0x33, &reg);
}

void DrawMouse()
{
  if (visible)
  {
    mouse_read(x, y, b);
    if (x1 != x || y1 != y || b1 != b)
    {
      x1 ^= x; x = x1 ^ x; x1 ^= x;
      y1 ^= y; y = y1 ^ y; y1 ^= y;
      b1 ^= b; b = b1 ^ b; b1 ^= b;
      putimage(x, y, buf, COPY_PUT);
      x1 ^= x; x = x1 ^ x; x1 ^= x;
      y1 ^= y; y = y1 ^ y; y1 ^= y;
      b1 ^= b; b = b1 ^ b; b1 ^= b;
      getimage(x, y, x + 16, y + 24, buf);
      MouseShape();
      x1 = x;
      y1 = y;
      b1 = b;
    }
  }
}


#endif
