#ifndef _PROCS_H_
#define _PROCS_H_
#include <string.h>
#include <time.h>
#include <dos.h>
#include "objects.cpp"
#include "defs.h"

void Delay(unsigned);
void ClearKbd();
void Draw3DBox(int x, int y, int w, int h);
void Draw3DHole(int x, int y, int w, int h, int color);

void Delay(unsigned clocks)
{
  long t = clock();
  while (clock() - t < clocks);
}

void ClearKbd()
{
  while (kbhit()) getch();
}

void Draw3DBox(int x, int y, int w, int h)
{
  setcolor(GRAY);
  line(x, y, x + w - 1, y);
  line(x, y, x, y + h - 1);
  setcolor(WHITE);
  line(x + 1, y + 1, x + 1, y + h - 3);
  line(x + 1, y + 1, x + w - 3, y + 1);
  setcolor(BLACK);
  line(x, y + h - 1, x + w - 1, y + h - 1);
  line(x + w - 1, y, x + w - 1, y + h - 1);
  setcolor(DARKGRAY);
  line(x + 1, y + h - 2, x + w - 2, y + h - 2);
  line(x + w - 2, y + 1, x + w - 2, y + h - 2);
  setfillstyle(1, GRAY);
  bar(x + 2, y + 2, x + w - 3, y + h - 3);
}

void Draw3DHole(int x, int y, int w, int h, int color)
{
  setcolor(DARKGRAY);
  line(x, y, x + w - 2, y);
  line(x, y, x, y + h - 2);
  setcolor(BLACK);
  line(x + 1, y + 1, x + w - 3, y + 1);
  line(x + 1, y + 1, x + 1, y + h - 3);
  setcolor(WHITE);
  line(x + w - 1, y + h - 1, x, y + h - 1);
  line(x + w - 1, y + h - 1, x + w - 1, y);
  setcolor(GRAY);
  line(x + w - 2, y + h - 2, x + 1, y + h - 2);
  line(x + w - 2, y + h - 2, x + w - 2, y + 1);
  setfillstyle(1, color);
  bar(x + 2, y + 2, x + w - 3, y + h - 3);
}


#endif

