;****************************************************************************
;*                               PALETTE.ASM
;*                       COPYRIGHT (C) 1999 MATI INC.
;****************************************************************************
IDEAL   

MODEL   SMALL     

LOCALS  @@        


CODESEG 

        PUBLIC    _SET_RGB 
        PUBLIC    _SET_ALL_PAL 
        PUBLIC    _FADE_IN 
        PUBLIC    _FADE_OUT 
        PUBLIC    _SET_NULL_PAL 
        PUBLIC    _SCROLL_PAL 
        R1        DB    0 
        G1        DB    0 
        B1        DB    0 
        R2        DB    0 
        G2        DB    0 
        B2        DB    0 

PROC    VERT_RET  FAR   
        CLI       
        MOV       DX,   03DAH 
@@1:    IN        AL,   DX 
        TEST      AL,   8 
        JZ        @@1   
@@2:    IN        AL,   DX 
        TEST      AL,   8 
        JNZ       @@2   
        STI       
        RET       
ENDP    


PROC    _SET_RGB  FAR   
        ARG       N:WORD, R:WORD, G:WORD, B:WORD 
        PUSH      BP    
        MOV       BP,   SP 
        MOV       DX,   3C8H 
        MOV       AX,   [N] 
        OUT       DX,   AL 
        INC       DX    
        MOV       AX,   [R] 
        OUT       DX,   AL 
        MOV       AX,   [G] 
        OUT       DX,   AL 
        MOV       AX,   [B] 
        OUT       DX,   AL 
        POP       BP    
        RET       
ENDP    


PROC    _SET_ALL_PAL FAR   
        ARG       PALETTE:DWORD 
        PUSH      BP    
        MOV       BP,   SP 
        PUSH      DS    
        LDS       SI,   [PALETTE] 
        XOR       CX,   CX 
        STD       
@@1:    MOV       DX,   3C8H 
        MOV       AL,   CL 
        OUT       DX,   AL 
        INC       DX    
        MOV       AX,   CX 
        SHL       AX,   2 
        INC       AX    
        INC       AX    
        PUSH      SI    
        ADD       SI,   AX 
        LODSB     
        SHR       AL,   2 
        OUT       DX,   AL 
        LODSB     
        SHR       AL,   2 
        OUT       DX,   AL 
        LODSB     
        SHR       AL,   2 
        OUT       DX,   AL 
        POP       SI    
        INC       CX    
        CMP       CX,   256 
        JB        @@1   
        CLD       
        POP       DS    
        POP       BP    
        RET       
ENDP    


PROC    _SET_NULL_PAL FAR   
        XOR       CX,   CX 
@@1:    MOV       DX,   3C8H 
        MOV       AL,   CL 
        OUT       DX,   AL 
        INC       DX    
        XOR       AL,   AL 
        OUT       DX,   AL 
        OUT       DX,   AL 
        OUT       DX,   AL 
        INC       CX    
        CMP       CX,   256 
        JB        @@1   
        RET       
ENDP    


PROC    DIVIDE    
        PUSH      DX    
        PUSH      BX    
        PUSH      BX    
        XOR       DX,   DX 
        MOV       BX,   100 
        MUL       BX    
        MOV       BX,   63 
        DIV       BX    
        XOR       DX,   DX 
        POP       BX    
        MUL       BX    
        MOV       BX,   100 
        DIV       BX    
        POP       BX    
        POP       DX    
        RET       
ENDP    


PROC    _FADE_IN  FAR   
        ARG       PALETTE:DWORD 
        PUSH      BP    
        MOV       BP,   SP 
        PUSH      DS    
        LDS       SI,   [PALETTE] 
        XOR       BX,   BX 
        STD       
@@1:    XOR       CX,   CX 
@@2:    MOV       DX,   3C8H 
        MOV       AL,   CL 
        OUT       DX,   AL 
        INC       DX    
        PUSH      SI    
        PUSH      BX    
        MOV       BX,   CX 
        SHL       BX,   2 
        INC       BX    
        INC       BX    
        ADD       SI,   BX 
        POP       BX    
        XOR       AH,   AH 
        LODSB     
        CALL      DIVIDE 
        SHR       AL,   2 
        OUT       DX,   AL 
        LODSB     
        CALL      DIVIDE 
        SHR       AL,   2 
        OUT       DX,   AL 
        LODSB     
        CALL      DIVIDE 
        SHR       AL,   2 
        OUT       DX,   AL 
        POP       SI    
        INC       CX    
        CMP       CX,   256 
        JB        @@2   
        CALL      FAR   PTR VERT_RET 
        INC       BX    
        CMP       BX,   64 
        JB        @@1   
        CLD       
        POP       DS    
        POP       BP    
        RET       
ENDP    


PROC    _FADE_OUT FAR   
        ARG       PALETTE:DWORD 
        PUSH      BP    
        MOV       BP,   SP 
        PUSH      DS    
        LDS       SI,   [PALETTE] 
        MOV       BX,   63 
        STD       
@@1:    XOR       CX,   CX 
@@2:    MOV       DX,   3C8H 
        MOV       AL,   CL 
        OUT       DX,   AL 
        INC       DX    
        PUSH      SI    
        PUSH      BX    
        MOV       BX,   CX 
        SHL       BX,   2 
        INC       BX    
        INC       BX    
        ADD       SI,   BX 
        POP       BX    
        XOR       AH,   AH 
        LODSB     
        CALL      DIVIDE 
        SHR       AL,   2 
        OUT       DX,   AL 
        LODSB     
        CALL      DIVIDE 
        SHR       AL,   2 
        OUT       DX,   AL 
        LODSB     
        CALL      DIVIDE 
        SHR       AL,   2 
        OUT       DX,   AL 
        POP       SI    
        INC       CX    
        CMP       CX,   256 
        JB        @@2   
        CALL      FAR   PTR VERT_RET 
        DEC       BX    
        JNS       @@1   
        CLD       
        POP       DS    
        POP       BP    
        RET       
ENDP    


PROC    _SCROLL_PAL FAR   
        ARG       START:WORD, COUNT:WORD 
        PUSH      BP    
        MOV       BP,   SP 
        PUSH      DI    
        PUSH      SI    
        MOV       CX,   [START] 
@@1:    MOV       DX,   3C7H 
        MOV       AL,   CL 
        OUT       DX,   AL 
        INC       DX    
        INC       DX    
        IN        AL,   DX 
        MOV       [R1], AL 
        IN        AL,   DX 
        MOV       [G1], AL 
        IN        AL,   DX 
        MOV       [B1], AL 
        DEC       DX    
        DEC       DX    
        MOV       AL,   CL 
        INC       AL    
        OUT       DX,   AL 
        INC       DX    
        INC       DX    
        IN        AL,   DX 
        MOV       [R2], AL 
        IN        AL,   DX 
        MOV       [G2], AL 
        IN        AL,   DX 
        MOV       [B2], AL 
        MOV       DX,   3C8H 
        MOV       AL,   CL 
        OUT       DX,   AL 
        INC       DX    
        MOV       AL,   [R2] 
        OUT       DX,   AL 
        MOV       AL,   [G2] 
        OUT       DX,   AL 
        MOV       AL,   [B2] 
        OUT       DX,   AL 
        DEC       DX    
        MOV       AL,   CL 
        INC       AL    
        OUT       DX,   AL 
        INC       DX    
        MOV       AL,   [R1] 
        OUT       DX,   AL 
        MOV       AL,   [G1] 
        OUT       DX,   AL 
        MOV       AL,   [B1] 
        OUT       DX,   AL 
        INC       CL    
        MOV       BX,   [START] 
        ADD       BX,   [COUNT] 
        CMP       CL,   BL 
        JB        @@1   
        POP       SI    
        POP       DI    
        POP       BP    
        RET       
ENDP    

END     

