#ifndef _TEXTURE_H_
#define _TEXTURE_H_
#include "graphics.h"
#include "defs.h"

#define SKY_TEX      0
#define WATER_TEX    1
#define BRICK_TEX    2
#define BRKWIN_TEX   3
#define BIN_TEX      4

void PutTexture(unsigned x, unsigned y, unsigned type);

void Texture1(unsigned x, unsigned y)
{
  int i = x, j;

  for (j = 0; j < 20; j++, i++)
  {
    i = i % 64;
    if (i < 32)
      V_LINE(x + j, y, 14, i + LS_START_COLOR + 40);
    else
      V_LINE(x + j, y, 14, 103 - i + LS_START_COLOR);
  }
}

void Texture2(unsigned x, unsigned y)
{
  PUT_IMAGE(x, y, 20, 14, SPRITES_ADDR + WATER_OFFSET);
}

void Texture3(unsigned x, unsigned y)
{
  PUT_IMAGE(x, y, 20, 14, SPRITES_ADDR + BRICK_OFFSET);
}

void Texture4(unsigned x, unsigned y)
{
}

void Texture5(unsigned x, unsigned y)
{
  PUT_IMAGE(x, y, 20, 14, SPRITES_ADDR + BINARY_OFFSET);
}

void PutTexture(unsigned x, unsigned y, unsigned type)
{
  switch (type)
  {
    case SKY_TEX: Texture1(x, y); break;
    case WATER_TEX: Texture2(x, y); break;
    case BRICK_TEX: Texture3(x, y); break;
    case BRKWIN_TEX: Texture4(x, y); break;
    case BIN_TEX: Texture5(x, y);
  }
}

#endif
