#include <time.h>
#include "graphics.h"
#include "defs.h"

#define O  28

char offsets[O] = {4,4,4,4,4,4,4,3,3,3,3,3,3,3,2,2,2,2,2,2,2,1,1,1,1,1,1,1};

class TMario {
    int x, y;
    int x1, y1, x2, y2;
    int sprite;
    int lives;
    int coins;
    int speed;
    int jump_time;
    int jump_flag;
    int alt_flag;
    int side, old_side;
    int index;
    char l, r;
    unsigned counter;
    void MoveMario(int dx, int dy);
  public:
    TMario(int x, int y);
    ~TMario();
    void HandleEvent(unsigned keycode);
    void Draw();
    int GetY();
    int GetX();
};

TMario::TMario(int x, int y)
{
  TMario::x = x;
  TMario::y = y;
  x1 = x;
  y1 = y;
  x2 = x;
  y2 = y;
  sprite = 0;
  lives = 3;
  coins = 0;
  l = 0;
  r = 0;
  counter = 0;
  speed = 1;
  jump_time = 0;
  jump_flag = 0;
  alt_flag = 0;
  side = 0;
  old_side = 0;
  index = O - 1;
}

TMario::~TMario()
{
}

void TMario::MoveMario(int dx, int dy)
{
  int t_x, t_y;
  char a, b, c, d, e, f;

  t_x = x + dx;
  t_y = y + dy;
  a = LevelTable[t_x / 20][(t_y - 5) / 14];
  b = LevelTable[(t_x + 19) / 20][(t_y - 5) / 14];
  c = LevelTable[t_x / 20][t_y / 14];
  d = LevelTable[(t_x + 19) / 20][t_y / 14];
  e = LevelTable[t_x / 20][(t_y + 13) / 14];
  f = LevelTable[(t_x + 19) / 20][(t_y + 13) / 14];

  if (!SPR_PROP[a] && !SPR_PROP[b] && !SPR_PROP[c] &&
      !SPR_PROP[d] && !SPR_PROP[e] && !SPR_PROP[f])
  {
    if (dy > 0)
    {
      if (index) index--;
      sprite = 2;
      jump_flag = 1;
    }
    else if (dy < 0)
      sprite = 3;

    x += dx;
    y += dy;
  }
  else
  {
    if (sprite > 1 || dx)
      sprite = 0;

    if (dy < 0)
      jump_time = 0;

    if (dx)
    {
      x += dx;
      if (dx > 0)
        x -= x % 20;
      else
        x = (x / 20 + 1) * 20;
    }

    if (dy)
    {
      index = O - 1;
      y += dy;
      if (dy > 0)
      {
        y -= y % 14;
        if (!alt_flag)
          jump_flag = 0;
      }
      else
        y = y / 14 * 14 + 9;
    }
  }
}

void TMario::HandleEvent(unsigned keycode)
{
  unsigned offs = 16 * (PAGE > 0);
  int t_x, t_y;

  if (!PAGE)
  {
    t_x = x1;
    t_y = y1;
  }
  else
  {
    t_x = x2;
    t_y = y2;
  }

  DrawTable[t_x / 20 + offs][t_y / 14 - 1] = 1;
  DrawTable[t_x / 20 + 1 + offs][t_y / 14 - 1] = 1;
  DrawTable[t_x / 20 + offs][t_y / 14] = 1;
  DrawTable[t_x / 20 + 1 + offs][t_y / 14] = 1;
  DrawTable[t_x / 20 + offs][t_y / 14 + 1] = 1;
  DrawTable[t_x / 20 + 1 + offs][t_y / 14 + 1] = 1;

  switch (keycode)
  {
    case 56: if (!jump_flag)
             {
               jump_time = O - 1;
               jump_flag = 1;
               alt_flag = 1;
             } break;
    case 184: jump_time = 0; jump_flag = 0; alt_flag = 0; break;
    case 29: speed = 2; break;
    case 157: speed = 1; break;
    case 75: l = speed; r = 0; side = 1; break;
    case 77: r = speed; l = 0; side = 0; break;
    case 203: l = 0; break;
    case 205: r = 0; break;
  }

  if (l && r) { l = 0; r = 0; counter = 0; }
  if (l || r)
  {
    counter++;
    if (counter > 10)
    {
      sprite ^= 1;
      counter = 0;
    }
  }
  else
    sprite = 0;

  if (r) MoveMario(speed, 0);
  if (l) MoveMario(-speed, 0);

  if (jump_time)
    MoveMario(0, -offsets[O - 1 - jump_time]);
  else
    MoveMario(0, offsets[index]);

  if (jump_time)
    jump_time--;

  if (!PAGE)
  {
    x1 = x;
    y1 = y;
  }
  else
  {
    x2 = x;
    y2 = y;
  }

  if (side != old_side)
    FLIP(SPRITES_ADDR + MARIO_OFFSET, 20, 112);

  old_side = side;
}

void TMario::Draw()
{
  PUT_RENDER_IMAGE(x, y - 14, 20, 14, SPRITES_ADDR + MARIO_OFFSET + sprite * 2 * SPRITE_SIZE);
  PUT_RENDER_IMAGE(x, y, 20, 14, SPRITES_ADDR + MARIO_OFFSET + sprite * 2 * SPRITE_SIZE + SPRITE_SIZE);
}

int TMario::GetY()
{
  return y;
}

int TMario::GetX()
{
  return x;
}
